/**
 * This class file was automatically generated by jASN1 v1.9.1-SNAPSHOT (http://www.openmuc.org)
 */

package org.openmuc.openiec61850.internal.mms.asn1;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Serializable;

import org.openmuc.jasn1.ber.BerLength;
import org.openmuc.jasn1.ber.BerTag;
import org.openmuc.jasn1.ber.ReverseByteArrayOutputStream;

public class ConfirmedServiceRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    public byte[] code = null;
    private GetNameListRequest getNameList = null;
    private ReadRequest read = null;
    private WriteRequest write = null;
    private GetVariableAccessAttributesRequest getVariableAccessAttributes = null;
    private DefineNamedVariableListRequest defineNamedVariableList = null;
    private GetNamedVariableListAttributesRequest getNamedVariableListAttributes = null;
    private DeleteNamedVariableListRequest deleteNamedVariableList = null;
    private FileOpenRequest fileOpen = null;
    private FileReadRequest fileRead = null;
    private FileCloseRequest fileClose = null;
    private FileDeleteRequest fileDelete = null;
    private FileDirectoryRequest fileDirectory = null;

    public ConfirmedServiceRequest() {
    }

    public ConfirmedServiceRequest(byte[] code) {
        this.code = code;
    }

    public void setGetNameList(GetNameListRequest getNameList) {
        this.getNameList = getNameList;
    }

    public GetNameListRequest getGetNameList() {
        return getNameList;
    }

    public void setRead(ReadRequest read) {
        this.read = read;
    }

    public ReadRequest getRead() {
        return read;
    }

    public void setWrite(WriteRequest write) {
        this.write = write;
    }

    public WriteRequest getWrite() {
        return write;
    }

    public void setGetVariableAccessAttributes(GetVariableAccessAttributesRequest getVariableAccessAttributes) {
        this.getVariableAccessAttributes = getVariableAccessAttributes;
    }

    public GetVariableAccessAttributesRequest getGetVariableAccessAttributes() {
        return getVariableAccessAttributes;
    }

    public void setDefineNamedVariableList(DefineNamedVariableListRequest defineNamedVariableList) {
        this.defineNamedVariableList = defineNamedVariableList;
    }

    public DefineNamedVariableListRequest getDefineNamedVariableList() {
        return defineNamedVariableList;
    }

    public void setGetNamedVariableListAttributes(
            GetNamedVariableListAttributesRequest getNamedVariableListAttributes) {
        this.getNamedVariableListAttributes = getNamedVariableListAttributes;
    }

    public GetNamedVariableListAttributesRequest getGetNamedVariableListAttributes() {
        return getNamedVariableListAttributes;
    }

    public void setDeleteNamedVariableList(DeleteNamedVariableListRequest deleteNamedVariableList) {
        this.deleteNamedVariableList = deleteNamedVariableList;
    }

    public DeleteNamedVariableListRequest getDeleteNamedVariableList() {
        return deleteNamedVariableList;
    }

    public void setFileOpen(FileOpenRequest fileOpen) {
        this.fileOpen = fileOpen;
    }

    public FileOpenRequest getFileOpen() {
        return fileOpen;
    }

    public void setFileRead(FileReadRequest fileRead) {
        this.fileRead = fileRead;
    }

    public FileReadRequest getFileRead() {
        return fileRead;
    }

    public void setFileClose(FileCloseRequest fileClose) {
        this.fileClose = fileClose;
    }

    public FileCloseRequest getFileClose() {
        return fileClose;
    }

    public void setFileDelete(FileDeleteRequest fileDelete) {
        this.fileDelete = fileDelete;
    }

    public FileDeleteRequest getFileDelete() {
        return fileDelete;
    }

    public void setFileDirectory(FileDirectoryRequest fileDirectory) {
        this.fileDirectory = fileDirectory;
    }

    public FileDirectoryRequest getFileDirectory() {
        return fileDirectory;
    }

    public int encode(OutputStream os) throws IOException {

        if (code != null) {
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
            return code.length;
        }

        int codeLength = 0;
        int sublength;

        if (fileDirectory != null) {
            codeLength += fileDirectory.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 77
            os.write(0x4D);
            os.write(0xBF);
            codeLength += 2;
            return codeLength;
        }

        if (fileDelete != null) {
            codeLength += fileDelete.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 76
            os.write(0x4C);
            os.write(0xBF);
            codeLength += 2;
            return codeLength;
        }

        if (fileClose != null) {
            codeLength += fileClose.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 74
            os.write(0x4A);
            os.write(0x9F);
            codeLength += 2;
            return codeLength;
        }

        if (fileRead != null) {
            codeLength += fileRead.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 73
            os.write(0x49);
            os.write(0x9F);
            codeLength += 2;
            return codeLength;
        }

        if (fileOpen != null) {
            codeLength += fileOpen.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 72
            os.write(0x48);
            os.write(0xBF);
            codeLength += 2;
            return codeLength;
        }

        if (deleteNamedVariableList != null) {
            codeLength += deleteNamedVariableList.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 13
            os.write(0xAD);
            codeLength += 1;
            return codeLength;
        }

        if (getNamedVariableListAttributes != null) {
            sublength = getNamedVariableListAttributes.encode(os);
            codeLength += sublength;
            codeLength += BerLength.encodeLength(os, sublength);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 12
            os.write(0xAC);
            codeLength += 1;
            return codeLength;
        }

        if (defineNamedVariableList != null) {
            codeLength += defineNamedVariableList.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 11
            os.write(0xAB);
            codeLength += 1;
            return codeLength;
        }

        if (getVariableAccessAttributes != null) {
            sublength = getVariableAccessAttributes.encode(os);
            codeLength += sublength;
            codeLength += BerLength.encodeLength(os, sublength);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 6
            os.write(0xA6);
            codeLength += 1;
            return codeLength;
        }

        if (write != null) {
            codeLength += write.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 5
            os.write(0xA5);
            codeLength += 1;
            return codeLength;
        }

        if (read != null) {
            codeLength += read.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 4
            os.write(0xA4);
            codeLength += 1;
            return codeLength;
        }

        if (getNameList != null) {
            codeLength += getNameList.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 1
            os.write(0xA1);
            codeLength += 1;
            return codeLength;
        }

        throw new IOException("Error encoding CHOICE: No element of CHOICE was selected.");
    }

    public int decode(InputStream is) throws IOException {
        return decode(is, null);
    }

    public int decode(InputStream is, BerTag berTag) throws IOException {

        int codeLength = 0;
        BerTag passedTag = berTag;

        if (berTag == null) {
            berTag = new BerTag();
            codeLength += berTag.decode(is);
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 1)) {
            getNameList = new GetNameListRequest();
            codeLength += getNameList.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 4)) {
            read = new ReadRequest();
            codeLength += read.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 5)) {
            write = new WriteRequest();
            codeLength += write.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 6)) {
            codeLength += BerLength.skip(is);
            getVariableAccessAttributes = new GetVariableAccessAttributesRequest();
            codeLength += getVariableAccessAttributes.decode(is, null);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 11)) {
            defineNamedVariableList = new DefineNamedVariableListRequest();
            codeLength += defineNamedVariableList.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 12)) {
            codeLength += BerLength.skip(is);
            getNamedVariableListAttributes = new GetNamedVariableListAttributesRequest();
            codeLength += getNamedVariableListAttributes.decode(is, null);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 13)) {
            deleteNamedVariableList = new DeleteNamedVariableListRequest();
            codeLength += deleteNamedVariableList.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 72)) {
            fileOpen = new FileOpenRequest();
            codeLength += fileOpen.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.PRIMITIVE, 73)) {
            fileRead = new FileReadRequest();
            codeLength += fileRead.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.PRIMITIVE, 74)) {
            fileClose = new FileCloseRequest();
            codeLength += fileClose.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 76)) {
            fileDelete = new FileDeleteRequest();
            codeLength += fileDelete.decode(is, false);
            return codeLength;
        }

        if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 77)) {
            fileDirectory = new FileDirectoryRequest();
            codeLength += fileDirectory.decode(is, false);
            return codeLength;
        }

        if (passedTag != null) {
            return 0;
        }

        throw new IOException("Error decoding CHOICE: Tag " + berTag + " matched to no item.");
    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        ReverseByteArrayOutputStream os = new ReverseByteArrayOutputStream(encodingSizeGuess);
        encode(os);
        code = os.getArray();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        appendAsString(sb, 0);
        return sb.toString();
    }

    public void appendAsString(StringBuilder sb, int indentLevel) {

        if (getNameList != null) {
            sb.append("getNameList: ");
            getNameList.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (read != null) {
            sb.append("read: ");
            read.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (write != null) {
            sb.append("write: ");
            write.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (getVariableAccessAttributes != null) {
            sb.append("getVariableAccessAttributes: ");
            getVariableAccessAttributes.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (defineNamedVariableList != null) {
            sb.append("defineNamedVariableList: ");
            defineNamedVariableList.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (getNamedVariableListAttributes != null) {
            sb.append("getNamedVariableListAttributes: ");
            getNamedVariableListAttributes.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (deleteNamedVariableList != null) {
            sb.append("deleteNamedVariableList: ");
            deleteNamedVariableList.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (fileOpen != null) {
            sb.append("fileOpen: ");
            fileOpen.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (fileRead != null) {
            sb.append("fileRead: ").append(fileRead);
            return;
        }

        if (fileClose != null) {
            sb.append("fileClose: ").append(fileClose);
            return;
        }

        if (fileDelete != null) {
            sb.append("fileDelete: ");
            fileDelete.appendAsString(sb, indentLevel + 1);
            return;
        }

        if (fileDirectory != null) {
            sb.append("fileDirectory: ");
            fileDirectory.appendAsString(sb, indentLevel + 1);
            return;
        }

        sb.append("<none>");
    }

}
