/*
 * Copyright 2011-17 Fraunhofer ISE, energy & meteo Systems GmbH and other contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package org.openmuc.openiec61850;

import java.io.IOException;
import java.nio.ByteBuffer;

import org.openmuc.josistack.AcseAssociation;
import org.openmuc.josistack.AcseAssociationListener;

final class AcseListener implements AcseAssociationListener {

    ServerSap serverSap;

    AcseListener(ServerSap serverSap) {
        this.serverSap = serverSap;
    }

    @Override
    public void connectionIndication(AcseAssociation acseAssociation, ByteBuffer psdu) {
        serverSap.connectionIndication(acseAssociation, psdu);
    }

    @Override
    public void serverStoppedListeningIndication(IOException e) {
        serverSap.serverStoppedListeningIndication(e);
    }

}
